# Localized resources for DscResourceDesigner

ConvertFrom-StringData @'
###PSLOC
ModuleParsingError=There was an error parsing the module file {0}
SchemaEncodingNotSupportedPrompt=The encoding for the schema file is not supported. Convert to Unicode?
SchemaEncodingNotSupportedError=The encoding for the schema file is not supported. Please use Unicode or ASCII.
SchemaFileReEncodingVerbose=Re-encoding the schema file in Unicode.
SchemaModuleReadError=Property {0} declared as Read in the schema, cannot be a parameter in the module.
SchemaModuleAttributeError=Property {0} has a different attribute in the schema than in the module.
SchemaModuleTypeError=Property {0} has a different type in the schema than in the module.
SchemaModuleValidateSetDiscrepancyError=The schema and module don't both have the ValidateSet tag for property {0}.
SchemaModuleValidateSetCountError=The ValidateSet tag has a different number of items between the schema and module.
SchemaModuleValidateSetItemError=The ValidateSet item {1} for property {0} in the schema was not found in the module.
ImportTestSchemaVerbose=The schema file has been verified.
ImportReadingPropertiesVerbose=Reading the properties from the schema file.
SchemaPathValidVerbose=The path to the schema file has been verified.
SchemaMofCompCheckVerbose=The schema file has passed mofcomp's syntax check.
SchemaDscContractsVerbose=Testing the schema file's compliance to Desired State Configuration's contracts.
AdminRightsError=You do not have Administrator rights to run this script. Please re-run this script as an Administrator.
PathIsInvalidError=There was an error creating the folder {0}.
SchemaNotFoundInDirectoryError=The expected file {0} was not found.
ModuleNotFoundInDirectoryError=The expected file {0} was not found.
ModuleNameNotFoundError=No module with the name {0} was found in $env:PSModulePath.
NewResourceKeyVerbose=Successfully found a property with the attribute Key.
NewResourceNameVerbose=Resource Name was found to be valid.
NewResourceUniqueVerbose=All of the properties had unique names.
NewResourcePathVerbose=The output path was valid.
NewModuleManifestPathVerbose=The module manifest was created for the specified module name.
DefaultAttribute=The attribute for the property was set to the default value: "Write"
NewResourceSuccessVerbose=The generated resource was tested and found acceptable.
TestResourceIndividualSuccessVerbose=The schema.mof and .psm1 files were both indivually correct.
TestResourceTestSchemaVerbose=Testing the schema.mof file.
TestResourceTestModuleVerbose=Testing the .psm1 file.
TestResourceGetMandatoryVerbose=Result of testing Get-TargetResource for it's mandatory properties: {0}.
TestResourceSetNoReadsVerbose=Result of testing Set-TargetResource for no read properties: {0}.
TestResourceGetNoReadsVerbose=Result of testing Get-TargetResource for no read properties: {0}.
ResourceError=Test-DscResource detected an error, so the generated files will be removed.
KeyArrayError=Key Properties can not be Arrays.
ValidateSetTypeError=ValidateSet item {0} did not match type {1}.
InvalidValidateSetUsageError=ValidateSet can not be used for Arrays, PSCredentials, and Hashtable.
InvalidPropertyNameError=Property name {0} must start with a character and contain only characters, digits, and underscores.
PropertyNameTooLongError=Property name {0} is longer than 255 characters.
InvalidResourceNameError=Resource name {0} must start with a character and contain only characters, digits, and underscores.
ResourceNameTooLongError=Resource name {0} is longer than 255 characters.
NoKeyError=At least one DscResourceProperty must have the attribute Key.
NonUniqueNameError=Multiple DscResourceProperties share the name {0}.
OverWriteManifestOperation=OverWrite manifest file.
ManifestNotOverWrittenWarning=The manifest file {0} was not updated.
OverWriteSchemaOperation=OverWrite schema.mof file.
SchemaNotOverWrittenWarning=The schema.mof file {0} was not updated.
OverWriteModuleOperation=OverWrite module file.
ModuleNotOverWrittenWarning=The module file {0} was not updated.
UsingWriteVerbose=Use this cmdlet to deliver information about command processing.
UsingWriteDebug=Use this cmdlet to write debug information while troubleshooting.
IfRebootRequired=Include this line if the resource requires a system reboot.
BadSchemaPath=The parameter -Schema must be a path to a .schema.mof file.
BadResourceMOdulePath=The parameter -ResourceModule must be a path to a .psm1 or .dll file.
SchemaParseError=There was an error parsing the Schema file.
GetCimClass-Error=There was an error retrieving the Schema. 
ImportResourceModuleError=There was an error importing the Resource Module.
KeyFunctionsNotDefined=The following functions were not found: {0}.
MissingOMI_BaseResourceError=The Schema must be defined as "class {0} : OMI_BaseResource".
ClassNameSchemaNameDifferentError=The Class name {0} does not match the Schema name {1}.
UnsupportedMofTypeError=In property {0}, the mof type {1} is not supported.
ValueMapValuesPairError=In property {0}, the qualifiers "ValueMap" and "Values" must be used together and specify identical values.
NoKeyTestError=At least one property must have the qualifier "Key".
InvalidEmbeddedInstance=In property {0}, only MSFT_Credential and MSFT_KeyValuePair are allowed as EmbeddedInstances.
EmbeddedInstanceCimTypeError=In property {0}, all EmbeddedInstances must be encoded as Strings.
GetTargetResourceOutWarning=Get-TargetResource should return a [Hashtable] mapping all schema properties to their values. Prepend the param block with [OutputType([Hashtable])].
GetTargetResourceOutError=Get-TargetResource should return a [Hashtable] mapping all schema properties to their values. Prepend the param block with [OutputType([Hashtable])].
SetTargetResourceOutError=Set-TargetResource should not return anything.
TestTargetResourceOutWarning=Test-TargetResource should return a [boolean]. Prepend the param block with [OutputType([Boolean])].
TestTargetResourceOutError=Test-TargetResource should return a [boolean]. Prepend the param block with [OutputType([Boolean])].
SetTestNotIdenticalError=Set-TargetResource and Test-TargetResource should take identical parameters.
SetTestMissingParameterError=Set-TargetResource and Test-TargetResource must take identical parameters. {0} is missing parameter {1} from {2}.
ModuleValidateSetError=Parameter {0} had a different ValidateSet attribute between function {1} and {2}.
ModuleMandatoryError=Parameter {0} had a different value for the Mandatory flag between function {1} and {2}.
ModuleTypeError=Parameter {0} had a different type between function {1} and {2}.
NoKeyPropertyError={0} must take at least one mandatory, non array parameter.
UnsupportedTypeError=In function {0}, the type {1} of parameter {2} is not supported.
SetTestMissingGetParameterError=Set-TargetResource and Test-TargetResource are missing the parameter {0} in Get-TargetResource.
GetParametersDifferentError=Set-TargetResource and Test-TargetResource must include all of the parameters from Get-TargetResource and their attributes must be identical.
GetMissingKeyOrRequiredError=The function Get-TargetResource must take all Key and Required properties, and they must be mandatory. There was an issue with property {0}.
SetAndTestMissingParameterError=The functions Set-TargetResource and Test-TargetResource must take all Key, Required and Write properties. There is an issue with the parameter {0} defined in the schema.
SetAndTestExtraParameterError=The functions Set-TargetResource and Test-TargetResource have an extra parameter {0} that is not defined in the schema.
GetTakesReadError=The function Get-TargetResource can not take the read property {0}, defined in the schema, as a parameter. 
SetTestTakeReadError=The functions Set-TargetResource and Test-TargetResource can not take the read property {0} defined in the schema as a parameter.
###PSLOC
'@

